package com.tmax.openframe;

import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.file.*;
import com.tmax.openframe.variable.COBTEST4_VariableContainer;
import com.tmax.openframe.variable.group.*;
import java.lang.Runnable;
import java.math.*;
import java.util.*;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 * <dl>
 * </dl>
 * <p>This describes files what declared in I/O sections: </p>
 * <ul>
 * <li>
 * RVL-F: file class {@code ->} {@link COBTEST4_FD_RVL_F}, record class {@code -> } {@link COBTEST4_RVL_REC}
 * <p>organization type: FILE_ORG_SEQUENTIAL</p>
 * <p>key: no key</p>
 * </li>
 * </ul>
 */
public class COBTEST4 implements Runnable {
    private @Getter Integer returnValue = 0;
    private @Getter COBTEST4_VariableContainer container = new COBTEST4_VariableContainer();
    COBTEST4_FD_RVL_F FD_RVL_F;
    Runnable UnnamedSentence = this::UnnamedSentence;
    Runnable DISP_RTN = this::DISP_RTN;
    Runnable MAIN_PROC_RTN = this::MAIN_PROC_RTN;
    Runnable MAIN_PROC_EXIT = this::MAIN_PROC_EXIT;
    Runnable WRIT_RTN = this::WRIT_RTN;
    Runnable WRIT_RTN_EXIT = this::WRIT_RTN_EXIT;
    Runnable READ_RVL_RTN = this::READ_RVL_RTN;
    Runnable READ_RVL_EXIT = this::READ_RVL_EXIT;
    Runnable GoTo;
    boolean Return;
    ArrayList<Runnable> MethodFlow = new ArrayList<>();
    {
        MethodFlow.add(UnnamedSentence);
        MethodFlow.add(DISP_RTN);
        MethodFlow.add(MAIN_PROC_RTN);
        MethodFlow.add(MAIN_PROC_EXIT);
        MethodFlow.add(WRIT_RTN);
        MethodFlow.add(WRIT_RTN_EXIT);
        MethodFlow.add(READ_RVL_RTN);
        MethodFlow.add(READ_RVL_EXIT);
    }

    public COBTEST4() {
        FD_RVL_F = new COBTEST4_FD_RVL_F();
    }

    public @Override void run() {
        run(UnnamedSentence, READ_RVL_EXIT);
    }

    private void run(Runnable start) {
        run(start, null);
    }

    private void run(Runnable start, Runnable end) {
        List<Runnable> runList;
        if (end == null) {
            runList = Collections.singletonList(start);
        } else {
            runList = MethodFlow.subList(MethodFlow.indexOf(start),
                    MethodFlow.indexOf(end) + 1);
        }
        int i = 0;
        while (i < runList.size()) {
            runList.get(i).run();
            if (GoTo != null) {
                for (Runnable runUnit : runList) {
                    if (GoTo == runUnit) {
                        i = runList.indexOf(runUnit);
                        GoTo = null;
                        break;
                    }
                }
                if (GoTo != null) {
                    return;
                }
            } else {
                i++;
            }
            if (Return) {
                return;
            }
        }
    }

    public void init() {
        container = new COBTEST4_VariableContainer();
        FD_RVL_F = new COBTEST4_FD_RVL_F();
    }

    void UnnamedSentence() {
        run(READ_RVL_RTN, READ_RVL_EXIT);
        if (GoTo != null || Return) {
            return;
        }
        while (!(StringUtils.stripEnd(container.getRVL_REC().getRVL_CONT_NO(),
                " ").compareTo(StringUtils.repeat((char) 0xFF, 13)) == 0)) {
            run(MAIN_PROC_RTN, MAIN_PROC_EXIT);
            if (GoTo != null || Return) {
                return;
            }
        }
    }

    void DISP_RTN() {
        System.out.println("<===== COBTEST6 START====================>");
        System.out.println(" FILE WRITE SAMPLE    ");
        System.out.println("----------------------------------------");
        System.out.print(" RVL-CNT            COUNT  = ");
        System.out.println(container.getCOUNT_AREA().getRVL_CNT());
        System.out.print(" REWRITE             COUNT  = ");
        System.out.println(container.getCOUNT_AREA().getWR_CNT());
        System.out.println("<===== COBTEST6 ENDT====================>");
        FD_RVL_F.close();
        Return = true;
        return;
    }

    void MAIN_PROC_RTN() {
        run(WRIT_RTN, WRIT_RTN_EXIT);
        if (GoTo != null || Return) {
            return;
        }
        run(READ_RVL_RTN, READ_RVL_EXIT);
        if (GoTo != null || Return) {
            return;
        }
    }

    void MAIN_PROC_EXIT() {
    }

    void WRIT_RTN() {
        System.out.print(" RVL-IITEM-GB            VALUE  = ");
        System.out.println(container.getRVL_REC().getRVL_IITEM_GB());
        if (StringUtils.stripEnd(container.getRVL_REC().getRVL_IITEM_GB(), " ")
                .compareTo("00") == 0) {
            container.getRVL_REC().setRVL_IITEM_GB("99");
        } else {
            container.getRVL_REC().setRVL_IITEM_GB("00");
        }
        FD_RVL_F.rewrite();
        container.getCOUNT_AREA().setWR_CNT(
                (long) (container.getCOUNT_AREA().getWR_CNT() + 1));
    }

    void WRIT_RTN_EXIT() {
    }

    void READ_RVL_RTN() {
        COBTEST4_RVL_REC temp_COBTEST4_RVL_REC1;
        temp_COBTEST4_RVL_REC1 = FD_RVL_F.readNext();
        if (temp_COBTEST4_RVL_REC1 != null) {
            container.setRVL_REC(temp_COBTEST4_RVL_REC1);
        } else if (FD_RVL_F.getFileStatus() == FileStatus.AT_END_CONDITION_SEQUENCED) {
            container.getRVL_REC().setRVL_CONT_NO(
                    StringUtils.repeat((char) 0xFF, 13));
            GoTo = READ_RVL_EXIT;
            return;
        }
        container.getCOUNT_AREA().setRVL_CNT(
                (long) (container.getCOUNT_AREA().getRVL_CNT() + 1));
    }

    void READ_RVL_EXIT() {
    }
}
